#include	"hole_punchd.h"


void	portSet(void)
{
	struct	addrinfo	hints;
	struct	forward		*fwd_pnt;
	int	err;
	int	yes = 1;
	char	PORT[10];

	time_t	atime;

//	httpd
        if (http_port > 0)
        {
		time(&atime);
                memset (&hints, 0x00, sizeof(hints));
                hints.ai_socktype = SOCK_STREAM;
                hints.ai_family = PF_INET;
                hints.ai_flags = AI_PASSIVE;
		memset (PORT, 0x00, 10);
                sprintf (PORT, "%d", http_port);
                if ((err = getaddrinfo (NULL, PORT, &hints, &http_serv)) != 0)
                {
                        fprintf (log_file, "%24.24s getaddrinfo error (http port:%d) %s\n",
                                ctime(&atime), http_port, gai_strerror(err));
                        http_port = 0;
                        if (http_serv != NULL)  freeaddrinfo (http_serv);
                        fflush (log_file);
                }
                else
                {
                        if ((http_sd = socket (http_serv->ai_family, http_serv->ai_socktype, http_serv->ai_protocol)) < 0)
                        {
                                time(&atime);
                                fprintf (log_file, "%24.24s HTTP TCP Socket not open. Already used this port:%d\n", ctime(&atime), http_port);
                                fflush (log_file);
                                http_port = 0;
                                if (http_serv != NULL)  freeaddrinfo (http_serv);
				close (http_sd);
				http_sd = 0;
			}
                        else
                        {
                                if (setsockopt (http_sd, SOL_SOCKET, SO_REUSEADDR, (const char *)&yes, sizeof(yes)))
                                {
                                        time(&atime);
                                        fprintf (log_file, "%24.24s error setsock opt on HTTP_PORT\n", ctime(&atime));
                                        fflush (log_file);
                                        http_port = 0;
                                        if (http_serv != NULL)  freeaddrinfo (http_serv);
                                        close (http_sd);
                                        http_sd = 0;
                                }
                                else
                                {
                                        if (bind (http_sd, http_serv->ai_addr, http_serv->ai_addrlen) != 0)
                                        {
                                                time (&atime);
                                                fprintf (log_file, "%24.24s error bind on HTTP_PORT %s\n", ctime(&atime), strerror(errno));
                                                fflush (log_file);
                                                http_port = 0;
                                        }
                                        else
                                        {
                                                if (listen (http_sd, 5))
                                                {
                                                        time (&atime);
                                                        fprintf (log_file, "%24.24s error listen on HTTP_PORT %s\n",
                                                                                ctime(&atime), strerror(errno));
                                                        http_port = 0;
                                                        if (http_serv != NULL)  freeaddrinfo (http_serv);
                                                        fflush (log_file);
                                                }
                                                else
                                                {
                                                        FD_SET (http_sd, &fd_save);
                                                        fprintf (log_file, "%24.24s HTTP Port %d open.\n",
                                                                        ctime(&atime), http_port);
                                                        fflush (log_file);
                                                }
                                        }
                                }
			}
		}
       
		if (http_port)
		{
			gt = malloc (sizeof (struct tm));
			cpu_fd = open ("/proc/stat", O_RDONLY);
		}
	}

//	json port
        if (json_port > 0)
        {
		FD_ZERO ((fd_set *)&json_fd);
		time(&atime);
                memset (&hints, 0x00, sizeof(hints));
                hints.ai_socktype = SOCK_STREAM;
                hints.ai_family = PF_INET;
                hints.ai_flags = AI_PASSIVE;
                sprintf (PORT, "%d", json_port);
                if ((err = getaddrinfo (NULL, PORT, &hints, &json_serv)) != 0)
                {
                        fprintf (log_file, "%24.24s getaddrinfo error (http port:%d) %s\n",
                                ctime(&atime), json_port, gai_strerror(err));
                        json_port = 0;
                        if (json_serv != NULL)  freeaddrinfo (json_serv);
                        fflush (log_file);
                }
                else
                {
                        if ((json_sd = socket (json_serv->ai_family, json_serv->ai_socktype, json_serv->ai_protocol)) < 0)
                        {
                                time(&atime);
                                fprintf (log_file, "%24.24s JSON TCP Socket not open. Already used this port:%d\n", ctime(&atime), json_port);
                                fflush (log_file);
                                json_port = 0;
                                if (json_serv != NULL)  freeaddrinfo (json_serv);
				close (json_sd);
				json_sd = 0;
			}
                        else
                        {
                                if (setsockopt (json_sd, SOL_SOCKET, SO_REUSEADDR, (const char *)&yes, sizeof(yes)))
                                {
                                        time(&atime);
                                        fprintf (log_file, "%24.24s error setsock opt on JSON_PORT\n", ctime(&atime));
                                        fflush (log_file);
                                        json_port = 0;
                                        if (json_serv != NULL)  freeaddrinfo (json_serv);
                                        close (json_sd);
                                        json_sd = 0;
                                }
                                else
                                {
                                        if (bind (json_sd, json_serv->ai_addr, json_serv->ai_addrlen) != 0)
                                        {
                                                time (&atime);
                                                fprintf (log_file, "%24.24s error bind on JSON_PORT %s\n", ctime(&atime), strerror(errno));
                                                fflush (log_file);
                                                json_port = 0;
                                        }
                                        else
                                        {
                                                if (listen (json_sd, 5))
                                                {
                                                        time (&atime);
                                                        fprintf (log_file, "%24.24s error listen on JSON_PORT %s\n",
                                                                                ctime(&atime), strerror(errno));
                                                        json_port = 0;
                                                        if (json_serv != NULL)  freeaddrinfo (json_serv);
                                                        fflush (log_file);
                                                }
                                                else
                                                {
                                                        FD_SET (json_sd, &fd_save);
                                                        fprintf (log_file, "%24.24s JSON Port %d open.\n",
                                                                        ctime(&atime), json_port);
                                                        fflush (log_file);
                                                }
                                        }
                                }
			}
		}
	}
}

